<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2006 pragmaMx Dev Team - http://pragmaMx.org
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * $Source: /home/www/dps3311/home/cvsroot/pragmamx/pragmamx_01/admin/modules/stories.php,v $
 * $Revision: 1.15 $
 * $Author: tora60 $
 * $Date: 2007/05/13 11:16:42 $
 * 
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

if (!defined("mxAdminFileLoaded")) die("Access Denied");
if (!mxGetAdminPref('radminarticle')) {
    vkpNewsNotAuthorized();
} 

/**
 */
function vkpStoriesHeader($title)
{
    $item[] = "<a href=\"admin.php?op=adminStory\" title=\"" . _ADDSTORY . "\">" . _ADDSTORY . "</a>";
    $item[] = "<a href=\"admin.php?op=submissions\" title=\"" . _ADMIN_NEWSNEW . "\">" . _ADMIN_NEWSNEW . "</a>";
    $item[] = "<a href=\"admin.php?op=currentStories\" title=\"" . _ADMIN_NEWSCURRENT . "\">" . _ADMIN_NEWSCURRENT . "</a>";
    $item[] = "<a href=\"admin.php?op=timedStories\" title=\"" . _ADMIN_NEWSTIMED . "\">" . _ADMIN_NEWSTIMED . "</a>";
    $item[] = "<a href=\"admin.php?op=CategoriesMenu\" title=\"" . _CATEGORIESADMIN . "\">" . _ADMIN_NEWSCATEGORIES . "</a>";
    $menu = implode(" | ", $item);
    GraphicAdmin();
    OpenTable();
    echo "<center><font class=\"title\"><b>" . $title . "</b></font><br><br>";
    echo "<font class=\"content\">[" . $menu . "]</font></center>";
    CloseTable();
    echo "<br>";
} 

/**
 */
function vkpNewsNotAuthorized()
{
    include("header.php");
    vkpStoriesHeader(_ARTICLEADMIN);
    OpenTable();
    echo "<center><b>" . _NOTAUTHORIZED1 . "</b><br><br>" . _NOTAUTHORIZED2 . "<br><br>" . _GOBACK . "</center>";
    CloseTable();
    include("footer.php");
} 

/**
 */
function vkpPutInHome($story)
{ 
    // // Achtung!!! ihome: 0 = Ja , 1 = Nein
    $sel1 = (empty($story['ihome'])) ? "checked" : "";
    $sel2 = (empty($story['ihome'])) ? "" : "checked";
    echo "<b>" . _PUBLISHINHOME . "</b>&nbsp;&nbsp;";
    echo "<input type=\"radio\" name=\"ihome\" value=\"0\" $sel1>" . _YES . "&nbsp;"
     . "<input type=\"radio\" name=\"ihome\" value=\"1\" $sel2>" . _NO . "<br>"
     . "&nbsp;&nbsp;&nbsp;<span class=\"tiny\">(" . _ONLYIFCATSELECTED . ")</span><br><br>";
} 

/**
 */
function DeleteStory($qid, $ok = 1)
{
    global $prefix;
    if (empty($ok)) {
        include ("header.php");
        vkpStoriesHeader(_SUBMISSIONSADMIN);
        OpenTable();
        echo "<center><font class=\"option\"><b>" . _SURETODELSTORY . "</b></font><br><br><br>"
         . "[&nbsp;<a href=\"admin.php?op=DeleteStory&qid=$qid&ok=1\">" . _YES . "</a> | "
         . "<a href=\"admin.php?op=submissions\">" . _NO . "</a>&nbsp;]"
         . "</center>";
        CloseTable();
        include("footer.php");
    } else {
        $result = sql_query("DELETE FROM ${prefix}_queue where qid=" . intval($qid));
        if (!$result) {
            mxErrorScreen("Sorry, the Story can't be deleted.");
            return;
        } 
        header("Location: admin.php?op=submissions");
    } 
} 

/**
 */
function SelectCategory($cat)
{
    global $prefix;
    $selcat = sql_query("select catid, title from ${prefix}_stories_cat order by title");
    $a = 1;
    echo "<b>" . _CATEGORY . ":</b><br> ";
    echo "<select name=\"catid\">";
    $sel = (empty($cat)) ? "selected" : "";
    echo "<option value=\"0\" $sel> (" . _ARTICLES . ")</option>";
    while (list($catid, $title) = sql_fetch_row($selcat)) {
        $sel = ($catid == $cat) ? "selected" : "";
        echo "<option value=\"$catid\" $sel>" . htmlspecialchars($title) . "</option>";
        $a++;
    } 
    echo "</select>"; 
    // [&nbsp;<a href=\"admin.php?op=AddCategory\">"._ADD."</a> | <a href=\"admin.php?op=EditCategory\">"._EDIT."</a> | <a href=\"admin.php?op=DelCategory\">"._DELETE."</a>&nbsp;]";
} 

/**
 * neu eingegangene Story - bearbeiten
 */
function DisplayStory($qid)
{
    global $prefix, $user_prefix;
    $result = sql_query("SELECT qid, uid, uname as informant, subject as title, story as hometext, storyext as bodytext, topic, alanguage FROM ${prefix}_queue where qid=" . intval($qid));
    $story = sql_fetch_assoc($result);
    $story["op"] = "DisplayStory";
    include("header.php");
    vkpStoriesHeader(_SUBMISSIONSADMIN);
    myform($story, 1, _ADDARTICLE);
    include ('footer.php');
} 

/**
 * neu eingegangene Story - Voransicht
 */
function previewStory($story, $title = _PREVIEWSTORY)
{
    include("header.php");
    vkpStoriesHeader(_ARTICLEADMIN);
    myform(mxStripSlashes($story), 1, $title);
    include ('footer.php');
} 

/**
 * ueber Submit_News eingegangene Story speichern
 */
function PostStory($story)
{
    global $prefix, $user_prefix;

    $story['ihome'] = (empty($story['ihome'])) ? 0 : 1; //// Achtung!!! acomm: 0 = Ja , 1 = Nein
    $story['acomm'] = (empty($story['acomm'])) ? 0 : 1; //// Achtung!!! acomm: 0 = Ja , 1 = Nein 
    // versch. Daten pruefen
    // hier nicht umleiten, sondern Vorschau mit Meldung zeigen
    if (empty($story['topic'])) $story['errmsg'][] = _ERRNOTOPIC;
    if (empty($story['title']) || $story['title'] == _NOSUBJECT) $story['errmsg'][] = _ERRNOTITLE;
    if (empty($story['hometext'])) $story['errmsg'][] = _ERRNOTEXT;
    if (isset($story['errmsg'])) {
        if (empty($story['qid'])) {
            $story['op'] = 'adminStory';
        } else {
            $story['op'] = 'DisplayStory';
        } 
        previewStory($story, _ADDARTICLE);
        return;
    } 
    // die Daten des aktuellen Admins
    $admindata = mxGetAdminData(); 
    // Erstellungsdatum ermitteln
    $year = (empty($story['year'])) ? date('Y') : $story['year'];
    $updDate = sprintf("%04d-%02d-%02d %02d:%02d:00", $year, $story['month'], $story['day'], $story['hour'], $story['min']); 
    // Datenbank anfuegen
    $qry = "INSERT INTO ${prefix}_stories SET 
        catid='" . intval($story['catid']) . "', 
        title='" . mxAddSlashesForSQL($story['title']) . "', 
        hometext='" . mxAddSlashesForSQL($story['hometext']) . "', 
        bodytext='" . mxAddSlashesForSQL($story['bodytext']) . "', 
        topic='" . intval($story['topic']) . "', 
        informant='" . mxAddSlashesForSQL($story['informant']) . "', 
        notes='" . mxAddSlashesForSQL($story['notes']) . "', 
        ihome='" . intval($story['ihome']) . "', 
        alanguage='" . mxAddSlashesForSQL($story['alanguage']) . "', 
        acomm='" . intval($story['acomm']) . "', 
        time='" . $updDate . "', 
        aid='" . mxAddSlashesForSQL($admindata['aid']) . "'
        ";
    $resultinsert = sql_query($qry); 
    // Wenn erfolgreich eingefuegt..
    if ($resultinsert) {
        // Umfrage anfuegen
        $story['sid'] = sql_insert_id();
        $story = mxInsertPoll($story); 
        // Userzaehler erhoehen
        $userinfo = mxGetUserDataFromUsername($story['informant']);
        if (!empty($userinfo['uid'])) {
            sql_query("update ${user_prefix}_users set counter=(counter+1) where uid=" . intval($userinfo['uid']));
        } 
        // Adminzaehler erhoehen
        sql_query("update ${prefix}_authors set counter=(counter+1) where aid='" . mxAddSlashesForSQL($admindata['aid']) . "'"); 
        // wenn ueber Submit_News gemeldet, den Queue Datensatz loeschen
        if (!empty($story['qid'])) {
            sql_query("DELETE FROM ${prefix}_queue where qid=" . intval($story['qid']));
        } 
        mxRedirect('admin.php?op=EditStory&sid=' . $story['sid'], _CHANGESAREOK, 1);
    } else {
        if (!empty($story['qid'])) {
            mxRedirect('admin.php?op=DisplayStory&qid=' . $story['qid'], _ERRNOSAVED, 3);
        } else {
            mxRedirect('admin.php?op=currentStories', _ERRNOSAVED, 3);
        } 
    } 
} 

/**
 * vorhandene bearbeitete Story speichern
 */
function ChangeStory($story)
{
    global $prefix, $user_prefix;

    $story['ihome'] = (empty($story['ihome'])) ? 0 : 1; //// Achtung!!! acomm: 0 = Ja , 1 = Nein
    $story['acomm'] = (empty($story['acomm'])) ? 0 : 1; //// Achtung!!! acomm: 0 = Ja , 1 = Nein 
    // versch. Daten pruefen
    // hier nicht umleiten, sondern Vorschau mit Meldung zeigen
    if (empty($story['topic'])) $story['errmsg'][] = _ERRNOTOPIC;
    if (empty($story['title']) || $story['title'] == _NOSUBJECT) $story['errmsg'][] = _ERRNOTITLE;
    if (empty($story['hometext'])) $story['errmsg'][] = _ERRNOTEXT;
    if (isset($story['errmsg'])) {
        $story['op'] = 'EditStory';
        previewStory($story, _EDITARTICLE);
        return;
    } 
    // die Daten des aktuellen Admins
    $admindata = mxGetAdminData(); 
    // Erstellungsdatum ermitteln
    $year = (empty($story['year'])) ? date('Y') : $story['year'];
    $updDate = sprintf("%04d-%02d-%02d %02d:%02d:00", $year, $story['month'], $story['day'], $story['hour'], $story['min']); 
    // Datenbank aktualisieren
    $qry = "UPDATE ${prefix}_stories SET 
        catid='" . intval($story['catid']) . "', 
        title='" . mxAddSlashesForSQL($story['title']) . "', 
        hometext='" . mxAddSlashesForSQL($story['hometext']) . "', 
        bodytext='" . mxAddSlashesForSQL($story['bodytext']) . "', 
        topic='" . intval($story['topic']) . "', 
        informant='" . mxAddSlashesForSQL($story['informant']) . "', 
        notes='" . mxAddSlashesForSQL($story['notes']) . "', 
        ihome='" . intval($story['ihome']) . "', 
        alanguage='" . mxAddSlashesForSQL($story['alanguage']) . "', 
        acomm='" . intval($story['acomm']) . "', 
        time='" . $updDate . "'
        WHERE sid=" . intval($story['sid']) . "";
    $resultupdate = sql_query($qry);
    $story = mxInsertPoll($story);

    if ($resultupdate) {
        // Umfrage anfuegen / aktualisieren
        $story = mxInsertPoll($story); 
        // Userzaehler aktualisieren, falls anderer User angegeben wurde
        $userinfo = mxGetUserDataFromUsername($story['informant']);
        if ($userinfo['uname'] != $story['informant_before']) {
            if (!empty($userinfo['uid'])) {
                sql_query("update ${user_prefix}_users set counter=(counter+1) where uid=" . intval($userinfo['uid']));
            } 
            sql_query("update ${user_prefix}_users set counter=(counter-1) where uname='" . mxAddSlashesForSQL(substr($story['informant_before'], 0, 25)) . "' AND counter > 0");
        } 
        mxRedirect('admin.php?op=EditStory&sid=' . $story['sid'], _CHANGESAREOK, 1);
    } else {
        mxRedirect('admin.php?op=EditStory&sid=' . $story['sid'], _ERRNOSAVED, 3);
    } 
    // header("Location: admin.php?op=currentStories");
    // header("Location: admin.php?op=EditStory&sid=$sid");
} 

/**
 * vorhandene Story bearbeiten
 */
function EditStory($sid)
{
    global $prefix;
    $qry = "SELECT * FROM ${prefix}_stories where sid=" . intval($sid) . "";
    $result = sql_query($qry);
    $story = sql_fetch_assoc($result);
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $story["time"], $datetime);
    $story["year"] = $datetime[1];
    $story["month"] = $datetime[2];
    $story["day"] = $datetime[3];
    $story["hour"] = $datetime[4];
    $story["min"] = $datetime[5];
    $story["op"] = "EditStory";
    include("header.php");
    vkpStoriesHeader(_ARTICLEADMIN);
    myform($story, 1, _EDITARTICLE);
    include ('footer.php');
} 

/**
 */
function RemoveStory($sid, $ok = 0)
{
    global $prefix, $user_prefix;
    if ($ok) {
        $ok = mxDelStories(array(intval($sid)));
        header("Location: admin.php?op=submissions");
    } else {
        include("header.php");
        vkpStoriesHeader(_ARTICLEADMIN);
        OpenTable();
        echo "<center>" . _REMOVESTORY . " $sid " . _ANDCOMMENTS;
        echo "<br><br>[&nbsp;<a href=\"admin.php?op=submissions\">" . _NO . "</a> | <a href=\"admin.php?op=RemoveStory&sid=$sid&ok=1\">" . _YES . "</a>&nbsp;]</center>";
        CloseTable();
        include("footer.php");
    } 
} 

/**
 * neue Story erstellen
 */
function adminStory()
{
    $story = array();
    $story["op"] = "adminStory";
    include("header.php");
    vkpStoriesHeader(_ARTICLEADMIN);
    myform($story, 0, _ADDARTICLE);
    include ('footer.php');
} 

/**
 * das Eingabeformular 
 *    Die Daten muessen ohne Backslashes kommen
 */
function myform($story, $preview = 0, $caption = '')
{
    global $prefix;
    $admindata = mxGetAdminData();
    if (empty($story['sid'])) $story['sid'] = 0;
    if (empty($story['catid'])) $story['catid'] = 0;
    if (empty($story['aid'])) $story['aid'] = $admindata['aid'];
    if (empty($story['title'])) $story['title'] = _NOSUBJECT;
    if (empty($story['hometext'])) $story['hometext'] = '';
    if (empty($story['bodytext'])) $story['bodytext'] = '';
    if (empty($story['topic'])) $story['topic'] = vkpGetFirstTopic();
    if (empty($story['informant'])) $story['informant'] = '';
    // if (empty($story['uid'])) $story['uid'] = 0;
    if (empty($story['notes'])) $story['notes'] = '';
    if (empty($story['ihome'])) $story['ihome'] = 0;
    if (empty($story['alanguage'])) $story['alanguage'] = '';
    if (empty($story['acomm'])) $story['acomm'] = 0; //// Achtung!!! acomm: 0 = Ja , 1 = Nein
    if (empty($story['qid'])) $story['qid'] = 0; // von der queue-Tabelle
    if (empty($story['pollID'])) $story['pollID'] = 0; 
    // Datum
    $today = getdate();
    if (empty($story['year'])) $story['year'] = $today['year'];
    if (empty($story['month'])) $story['month'] = $today['mon'];
    if (empty($story['day'])) $story['day'] = $today['mday'];
    if (empty($story['hour'])) $story['hour'] = $today['hours'];
    if (empty($story['min'])) $story['min'] = $today['minutes'];
    echo '<form name="snews" action="admin.php" method="post">';
    OpenTable();
    if ($caption) {
        echo '<center><font class="option"><b>' . $caption . '</b></font></center><br><br>';
    } 
    if (isset($story['errmsg'])) {
        openTableAl();
        echo '<div style="text-align: left;"><h2>' . _ERROROCCURS . '</h2><ul><li>' . implode('</li><li>', $story['errmsg']) . '</li></ul></div>';
        closeTableAl();
        echo '<br>';
    } else if ($preview) {
        vkpStoryPreview($story);
    } 
    echo '<div class="content">';
    vkpNewsSelectTopicCat($story);
    vkpPutInHome($story); //// Achtung!!! ihome: 0 = Ja , 1 = Nein
    addNewsTextFields($story);
    vkpAutomatedSelect($story['year'], $story['day'], $story['month'], $story['hour'], $story['min']);
    vkpNewsSelectActComments($story['acomm']); //// Achtung!!! acomm: 0 = Ja , 1 = Nein 
    vkpNewsSelectLanguage($story['alanguage']);
    vkpUsernameField ($story);
    echo '<input type="hidden" name="sid" value="' . $story['sid'] . '">';
    echo '<input type="hidden" name="qid" value="' . $story['qid'] . '">';
    echo '<input type="hidden" name="aid" value="' . $story['aid'] . '">';
    echo '<br><br><br>';
    echo '<select name="op">';
    if ($story['op'] == 'DisplayStory' || $story['op'] == 'PreviewAgain') {
        echo '<option value="PreviewAgain">' . _PREVIEWSTORY . '</option>';
    } 
    if ($story['op'] == 'DisplayStory' || $story['op'] == 'PreviewAgain' || $story['op'] == 'adminStory' || $story['op'] == 'PreviewAdminStory') {
        echo '<option value="PostStory">' . _POSTSTORY . '</option>';
    } 
    if ($story['op'] == 'adminStory' || $story['op'] == 'PreviewAdminStory') {
        echo '<option value="PreviewAdminStory">' . _PREVIEWSTORY . '</option>';
    } 
    if ($story['op'] == 'EditStory') {
        echo '<option value="ChangeStory">' . _SAVECHANGES . '</option>';
    } 
    echo '</select>';
    echo '<input type="submit" value="' . _OK . '">';
    if ($story['op'] == 'DisplayStory' || $story['op'] == 'PreviewAgain') {
        echo ' &nbsp;&nbsp; [&nbsp;<a href="admin.php?op=DeleteStory&amp;qid=' . $story['qid'] . '&amp;ok=0">' . _DELETE . '</a>&nbsp;]';
    } else if ($story['op'] == 'EditStory') {
        echo ' &nbsp;&nbsp; [&nbsp;<a href="admin.php?op=RemoveStory&amp;sid=' . $story['sid'] . '&amp;ok=0">' . _DELETE . '</a>&nbsp;]';
    } 
    echo '</div>';
    CloseTable(); 
    // Umfrage
    $pollTitle = '';
    $optionText = array('', '', '', '', '', '', '', '', '', '', '', '', '', ''); // 13, wegen der unnoetigen 0
    if (!empty($story['pollID']) && !empty($story['sid'])) {
        // bestehender Artikel
        $readonly = ' readonly="readonly"';
        $editlink = '<p align="center">[&nbsp;<a href="admin.php?op=polledit&pollID=' . $story['pollID'] . '" target="_blank">' . _EDITPOLL . '</a>&nbsp;]</p>';
        $result = sql_query("SELECT pollTitle FROM ${prefix}_poll_desc WHERE pollID=" . intval($story['pollID']) . " AND pollactive=1");
        list($pollTitle) = sql_fetch_row($result);
        $result = sql_query("SELECT optionText, voteID FROM ${prefix}_poll_data WHERE (pollID=" . intval($story['pollID']) . ") AND (optionText<>'') ORDER BY voteID");
        while (list($text, $voteID) = sql_fetch_row($result)) {
            $optionText[$voteID] = $text;
        } 
    } else {
        // neuer Artikel
        $readonly = '';
        $editlink = '<span class="tiny">' . _LEAVEBLANKTONOTATTACH . '</span>';
        $pollTitle = (empty($story['pollTitle'])) ? '' : $story['pollTitle'];
        $optionText = (empty($story['optionText'])) ? $optionText : $story['optionText'];
    } 
    echo '<br>';
    OpenTable();
    echo '<center><p class="title"><b>' . _ATTACHAPOLL . '</b></p><br>'
     . $editlink . '<br><br>'
     . '<table border="0" cellspacing="0" cellpadding="3">'
     . '<tr><td><font class="content">' . _POLLTITLE . ':</font></td><td><input type="text" name="pollTitle" value="' . $pollTitle . '" size="50" maxlength="100"' . $readonly . '></td></tr>'
     . '<tr><td colspan="2" align="center"><br><font class="content">' . _POLLEACHFIELD . '</font></td></tr>';
    for($i = 1; $i <= 12; $i++) {
        echo '<tr>'
         . '<td><font class="content">' . _OPTION . ' ' . $i . ':</font></td><td><input type="text" name="optionText[' . $i . ']" value="' . mxEntityQuotes(@$optionText[$i]) . '" size="50" maxlength="50"' . $readonly . '></td>'
         . '</tr>';
    } 
    echo '<input type="hidden" name="pollID" value="' . $story['pollID'] . '">'
     . "</table></center>";
    CloseTable();
    echo '</form>';
} 

/**
 */
function submissions()
{
    global $bgcolor1, $bgcolor2, $prefix;
    $img_delete = mxCreateImage("images/delete.gif", _DELETE);
    $img_edit = mxCreateImage("images/edit.gif", _EDIT);
    $img_view = mxCreateImage("images/view.gif", _SHOW);

    include ("header.php");
    $result = sql_query("SELECT qid, subject, timestamp, alanguage FROM ${prefix}_queue order by timestamp");
    $dummy = 0;
    $out = "";
    while (list($qid, $title, $time, $alanguage) = sql_fetch_row($result)) {
        if ($qid) $xqid = $qid;
        $title = (empty($title)) ? _NOSUBJECT : $title;
        $alanguage = (empty($alanguage)) ? _ALL : $alanguage;
        $out .= "<tr bgcolor=\"$bgcolor1\">\n";
        $out .= "<td><font class=\"content\">&nbsp;" . ($dummy + 1) . "</font></td>\n";
        $out .= "<td><font class=\"content\">&nbsp;" . formatTimestamp($time) . "&nbsp;</font></td>\n";
        $out .= "<td><font class=\"content\">&nbsp;<a href=\"admin.php?op=DisplayStory&qid=" . $qid . "\">" . $title . "</a></font></td>\n";
        $out .= "<td><font class=\"content\">" . $alanguage . "</font></td>\n";
        $out .= "<td align=\"center\"><a href=\"admin.php?op=DisplayStory&qid=" . $qid . "\">" . $img_view . "</a>&nbsp;<a href=\"admin.php?op=DeleteStory&qid=" . $qid . "&ok=0\">" . $img_delete . "</a></td>\n";
        $out .= "</tr>";
        $dummy++;
    } 
    if ($dummy == 1 && isset($xqid)) {
        header("Location: admin.php?op=DisplayStory&qid=$xqid");
        exit;
    } 

    vkpStoriesHeader(_SUBMISSIONSADMIN);
    OpenTable();
    if (empty($dummy)) {
        echo "<center><font class=\"title\"><b>" . _NOSUBMISSIONS . "</b></font></center>\n";
    } else {
        echo "<center><font class=\"content\"><b>" . _NEWSUBMISSIONS . "</b></font><br><br>\n";
        echo "<table width=\"100%\" border=\"0\" bgcolor=\"$bgcolor2\" cellspacing=\"1\" cellpadding=\"1\">\n";
        echo $out;
        echo "</table>\n";
    } 
    CloseTable();
    include ("footer.php");
} 

/**
 */
function currentStories()
{
    global $bgcolor1, $bgcolor2, $prefix;
    $countview = 20;
    extract(mxGetAdminData());
    include ("header.php");

    $img_delete = mxCreateImage("images/delete.gif", _DELETE);
    $img_edit = mxCreateImage("images/edit.gif", _EDIT);
    $img_view = mxCreateImage("images/view.gif", _SHOW);

    $queryalang = (empty($admlanguage) && !$radminsuper) ? "WHERE `time` <= now()" : "WHERE alanguage='" . $admlanguage . "' AND `time` <= now() ";
    $queryalang = ($radminsuper) ? "WHERE `time` <= now()" : $queryalang;

    $qry = "select sid, aid as s_aid, title, time, topic, informant, alanguage from ${prefix}_stories $queryalang order by time desc";
    $result = sql_query($qry);
    $dummy = 0;
    $out = "";
    $out2 = "";
    while ($story = sql_fetch_assoc($result)) {
        extract($story);
        $title = (empty($title)) ? _NOSUBJECT : $title;
        if ($dummy < $countview) {
            $alanguage = (empty($alanguage)) ? _ALL : $alanguage;
            $out .= "<tr bgcolor=\"$bgcolor1\">\n";
            $out .= "<td><font class=\"content\">" . ($dummy + 1) . "</font></td>\n";
            $out .= "<td nowrap><font class=\"content\">" . formatTimestamp($time) . "</font></td>\n";
            $out .= "<td><font class=\"content\">" . $title . "</font></td>\n";
            $out .= "<td><font class=\"content\">" . $alanguage . "</font></td>\n";
            $out .= "<td align=\"center\"><a href=\"admin.php?op=EditStory&sid=" . $sid . "\">" . $img_edit . "</a>&nbsp;<a href=\"admin.php?op=RemoveStory&sid=$sid\">" . $img_delete . "</a></td>\n";
            $out .= "</tr>";
        } else {
            $out2 .= "<option value=\"" . $sid . "\">" . $time . " - " . htmlspecialchars($title) . "</option>\n";
        } 
        $dummy++;
    } 
    if ($dummy == 1 && isset($xsid)) {
        header("Location: admin.php?op=DisplayStory&sid=$xsid");
        exit;
    } 

    vkpStoriesHeader(_ARTICLEADMIN);
    OpenTable();
    if (empty($dummy)) {
        echo "<center><font class=\"title\"><b>" . _ADMIN_NEWSNOARTICLES . "</b></font></center>\n";
    } else {
        echo "<center><font class=\"content\"><b>" . _LAST . " " . $countview . " " . _ARTICLES . "</b></font><br><br>\n";
        echo "<table width=\"100%\" border=\"0\" bgcolor=\"$bgcolor2\" cellspacing=\"1\" cellpadding=\"1\">\n";
        echo $out;
        echo "</table>\n";
        if ($out2) {
            CloseTable();
            echo "<br>";
            OpenTable();
            echo "<center><font class=\"content\"><b>" . _ADMIN_NEWSOLD . "</b> (" . ($dummy - $countview) . ")</font></center><br>\n";
            echo "
<form action=\"admin.php\" method=\"post\">
<select name=\"sid\" size=\"15\">" . $out2 . "</select><br><br>
<select name=\"op\">
<option value=\"EditStory\" selected=\"selected\">" . _EDIT . "</option>
<option value=\"RemoveStory\">" . _DELETE . "</option>
</select>
<input type=\"submit\" value=\"" . _GO . "\">
</form>";
        } 
    } 
    CloseTable();
    include ("footer.php");
} 

/**
 */
function timedstories()
{
    global $bgcolor1, $bgcolor2, $prefix;
    $countview = 20;
    extract(mxGetAdminData());
    include ("header.php");

    $img_delete = mxCreateImage("images/delete.gif", _DELETE);
    $img_edit = mxCreateImage("images/edit.gif", _EDIT);
    $img_view = mxCreateImage("images/view.gif", _SHOW);

    $queryalang = (empty($admlanguage) && !$radminsuper) ? "WHERE `time` > now() " : "WHERE alanguage='" . $admlanguage . "' AND `time` > now()";
    $queryalang = ($radminsuper) ? "WHERE `time` > now() " : $queryalang;

    $qry = "select sid, aid as s_aid, title, time, topic, informant, alanguage from ${prefix}_stories $queryalang order by time desc";
    $result = sql_query($qry);
    $dummy = 0;
    $out = "";
    $out2 = "";
    while ($story = sql_fetch_assoc($result)) {
        extract($story);
        $title = (empty($title)) ? _NOSUBJECT : $title;
        if ($dummy < $countview) {
            $alanguage = (empty($alanguage)) ? _ALL : $alanguage;
            $out .= "<tr bgcolor=\"$bgcolor1\">\n";
            $out .= "<td><font class=\"content\">" . ($dummy + 1) . "</font></td>\n";
            $out .= "<td nowrap><font class=\"content\">" . formatTimestamp($time) . "</font></td>\n";
            $out .= "<td><font class=\"content\">" . $title . "</font></td>\n";
            $out .= "<td><font class=\"content\">" . $alanguage . "</font></td>\n";
            $out .= "<td align=\"center\"><a href=\"admin.php?op=EditStory&sid=" . $sid . "\">" . $img_edit . "</a>&nbsp;<a href=\"admin.php?op=RemoveStory&sid=$sid\">" . $img_delete . "</a></td>\n";
            $out .= "</tr>";
        } else {
            $out2 .= "<option value=\"" . $sid . "\">" . $time . " - " . htmlspecialchars($title) . "</option>\n";
        } 
        $dummy++;
    } 
    if ($dummy == 1 && isset($xsid)) {
        header("Location: admin.php?op=DisplayStory&sid=$xsid");
        exit;
    } 

    vkpStoriesHeader(_ARTICLEADMIN);
    OpenTable();
    if (empty($dummy)) {
        echo "<center><font class=\"title\"><b>" . _NOAUTOARTICLES . "</b></font></center>\n";
    } else {
        echo "<center><font class=\"content\"><b>" . _LAST . " " . $countview . " " . _ARTICLES . "</b></font><br><br>\n";
        echo "<table width=\"100%\" border=\"0\" bgcolor=\"$bgcolor2\" cellspacing=\"1\" cellpadding=\"1\">\n";
        echo $out;
        echo "</table>\n";
        if ($out2) {
            CloseTable();
            echo "<br>";
            OpenTable();
            echo "<center><font class=\"content\"><b>" . _ADMIN_NEWSOLD . "</b> (" . ($dummy - $countview) . ")</font></center><br>\n";
            echo "
<form action=\"admin.php\" method=\"post\">
<select name=\"sid\" size=\"15\">" . $out2 . "</select><br><br>
<select name=\"op\">
<option value=\"EditStory\" selected=\"selected\">" . _EDIT . "</option>
<option value=\"RemoveStory\">" . _DELETE . "</option>
</select>
<input type=\"submit\" value=\"" . _GO . "\">
</form>";
        } 
    } 
    CloseTable();
    include ("footer.php");
} 

/**
 */
function vkpUsernameField ($story)
{
    if (empty($story['informant'])) {
        if ($GLOBALS['op'] == 'adminStory') {
            $userinfo = mxGetUserData();
            $story['informant'] = $userinfo['uname'];
        } else {
            $story['informant'] = '';
        }
    }
    if (empty($userinfo) && !empty($story['informant'])) {
        $userinfo = mxGetUserDataFromUsername($story['informant']);
    }
    $informant_before = (isset($story['informant_before'])) ? $story['informant_before'] : $story['informant'];
    echo '<br><b>' . _SUBMITTER . ':</b><br>
    <input type="text" name="informant" size="28" maxlength="25" value="' . mxEntityQuotes($story['informant']) . '">
    <input type="hidden" name="informant_before" value="' . mxEntityQuotes($informant_before) . '">
    ';
    if (!empty($userinfo['uid'])) {
        // thx to diabolo...
        echo '&nbsp;&nbsp;<span class="content">
        [&nbsp;<a href="mailto:' . $userinfo['email'] . '">' . _SENDEMAILUSER . '</a> 
        | <a href="modules.php?name=Private_Messages&amp;file=reply&amp;send=1&amp;uname=' . $story['informant'] . '" target="_blank">' . _SENDPMUSER . '</a>&nbsp;]
        </span>';
    } 
} 

/**
 * #####   Categorie-Functions   #################
 */
function CategoriesMenu()
{
    global $prefix;
    $qry = "SELECT ${prefix}_stories_cat.catid, ${prefix}_stories_cat.title, Count(${prefix}_stories.sid) AS anz
        FROM ${prefix}_stories_cat LEFT JOIN ${prefix}_stories 
        ON ${prefix}_stories_cat.catid = ${prefix}_stories.catid
        GROUP BY ${prefix}_stories_cat.catid, ${prefix}_stories_cat.title
        ORDER BY ${prefix}_stories_cat.title";
    $result = sql_query($qry);
    while (list($catid, $title, $anz) = sql_fetch_row($result)) {
        $tit = base64_encode($title);
        $fields[] = "<tr><td><form action='admin.php' method='post'>
<b>" . htmlspecialchars($title) . "</b></td><td>
<input type='text' name='title' value='" . htmlspecialchars($title) . "' size='22' maxlength='20'>
<input type='hidden' name='op' value='SaveEditCategory'>
<input type='hidden' name='catid' value='$catid'>
<input type='hidden' name='anz' value='$anz'>
<input type='submit' value='" . _EDIT . "'>&nbsp;&nbsp;
</form></td>
<td><a href='admin.php?op=DelCategory&catid=$catid&anz=$anz&tit=$tit'>" . _DELETE . "</a></td><td align='right'>&nbsp;&nbsp;" . $anz . " " . _ARTICLES . "</td>
</tr>";
    } 

    $fields[] = "<tr><td colspan='3'><br></td></tr>
<tr><td><form action='admin.php' method='post'>
<b>" . _CATEGORYADD . "</b></td><td>
<input type='text' name='title' value='' size='22' maxlength='20'>
<input type='hidden' name='op' value='SaveCategory'>
<input type='submit' value='" . _SAVE . "'>
</form></td><td colspan='2'><a name='AddCategory'>&nbsp;</a>
</td>
</tr>";

    include ("header.php");
    vkpStoriesHeader(_CATEGORIESADMIN);
    OpenTable();
    echo "<table border='0'>";
    echo implode("\n", $fields);
    echo "</table>";
    CloseTable();
    include("footer.php");
} 

/**
 */
function SaveCategory($pvs)
{
    global $prefix;
    $pvs = mxAddSlashesForSQL($pvs);
    extract($pvs);
    $result = sql_query("select catid from ${prefix}_stories_cat where title='" . $title . "'");
    list($check) = sql_fetch_row($result);
    if ($check) {
        $what1 = _CATEXISTS;
        $what2 = _GOBACK;
    } else {
        $what1 = _CATADDED;
        $what2 = "[&nbsp;<a href='admin.php?op=CategoriesMenu'>" . _CATEGORIESADMIN . "</a>&nbsp;]";
        $result = sql_query("INSERT INTO ${prefix}_stories_cat (title, counter) values ('" . $title . "', 0)");
        if (!$result) {
            $what1 = _ERRNOSAVED;
        } else {
            $ok = true;
        } 
    } 
    if (isset($ok)) {
        header("Location: admin.php?op=CategoriesMenu");
    } else {
        include ("header.php");
        vkpStoriesHeader(_CATEGORIESADMIN);
        OpenTable();
        echo "<center><font class=\"content\"><b>" . $what1 . "</b></font><br><br>";
        echo $what2 . "</center>";
        CloseTable();
        include("footer.php");
    } 
} 

/**
 */
function SaveEditCategory($pvs)
{
    global $prefix;
    $pvs = mxAddSlashesForSQL($pvs); 
    // mxDebugFuncVars($pvs);
    extract($pvs);
    $catid = (int)$catid;
    $result = sql_query("select catid from ${prefix}_stories_cat where title='$title'");
    list($check) = sql_fetch_row($result);
    if ($check) {
        $what1 = _CATEXISTS;
        $what2 = _GOBACK;
    } else {
        $what1 = _CATSAVED . " (" . $title . ")";
        $what2 = "[&nbsp;<a href='admin.php?op=CategoriesMenu'>" . _CATEGORIESADMIN . "</a>&nbsp;]";
        $result = sql_query("update ${prefix}_stories_cat set title='" . ($title) . "' where catid=$catid");
        if (!$result) {
            $what1 = _ERRNOSAVED;
        } else {
            $ok = true;
        } 
    } 
    if (isset($ok)) {
        header("Location: admin.php?op=CategoriesMenu");
    } else {
        include ("header.php");
        vkpStoriesHeader(_CATEGORIESADMIN);
        OpenTable();
        echo "<center><font class=\"content\"><b>" . $what1 . "</b></font><br><br>";
        echo $what2 . "</center>";
        CloseTable();
        include("footer.php");
    } 
} 

/**
 */
function DelCategory($gvs)
{
    global $prefix;
    extract($gvs);
    $title = base64_decode($tit);
    $catid = (int)$catid; 
    // exit;
    include ("header.php");
    vkpStoriesHeader(_CATEGORIESADMIN);
    OpenTable();
    echo "<center><font class=\"option\"><b>";
    if (empty($anz)) {
        sql_query("DELETE FROM ${prefix}_stories_cat where catid=" . intval($catid));
        echo _CATDELETED . "</b></font> (" . $title . ")<br><br><a href='admin.php?op=CategoriesMenu'>" . _CATEGORIESADMIN . "</a>";
    } else {
        echo _DELETECATEGORY . "</b></font><br>";
        echo "<br><br><b>" . _WARNING . ":</b> " . _THECATEGORY . " <b>" . htmlspecialchars($title) . "</b> " . _HAS . " <b>" . $anz . "</b> " . _STORIESINSIDE . "<br><br>"
         . _DELCATWARNING1 . "<br>" . _DELCATWARNING2 . "<br><br>" . _DELCATWARNING3 . "<br><br>"
         . "[&nbsp;<a href=\"admin.php?op=YesDelCategory&catid=$catid\">" . _YESDEL . "</a> | "
         . "<a href=\"admin.php?op=NoMoveCategory&catid=$catid&tit=$tit\">" . _NOMOVE . "</a>]<br><br>" . _GOBACK . " ";
    } 
    echo "</center>";
    CloseTable();
    include("footer.php");
} 

/**
 */
function YesDelCategory()
{
    global $prefix;
    $result1 = sql_query("DELETE FROM ${prefix}_stories_cat where catid=" . intval($_GET['catid']));
    if ($result1) {
        $result2 = sql_query("select sid from ${prefix}_stories where catid=" . intval($_GET['catid']));
        while (list($sid) = sql_fetch_row($result2)) {
            $allsid[] = $sid;
        } 
        if (isset($allsid)) {
            $ok = mxDelStories($allsid);
        } 
    } 
    header("Location: admin.php?op=CategoriesMenu");
} 

/**
 */
function NoMoveCategory($request)
{
    global $prefix; 
    // mxDebugFuncVars($request);
    extract($request);
    $catid = (int)$catid;
    $title = base64_decode($tit);
    include ("header.php");
    vkpStoriesHeader(_CATEGORIESADMIN);
    OpenTable();
    echo "<center><font class=\"option\"><b>" . _MOVESTORIES . "</b></font><br><br>";
    if (empty($newcat)) {
        echo _ALLSTORIES . " <b>$title</b> " . _WILLBEMOVED . "<br><br>";
        echo "<form action=\"admin.php\" method=\"post\">";
        echo "<b>" . _SELECTNEWCAT . ":</b> ";
        echo "<select name=\"newcat\">";
        echo "<option value=\"-1\"> (" . _ARTICLES . ")</option>";
        $selcat = sql_query("select catid, title from ${prefix}_stories_cat WHERE catid<>" . intval($catid) . " order by title");
        while (list($newcat, $title) = sql_fetch_row($selcat)) {
            echo "<option value=\"$newcat\">" . htmlspecialchars($title) . "</option>";
        } 
        echo "</select>";
        echo "<input type=\"hidden\" name=\"catid\" value=\"$catid\">";
        echo "<input type=\"hidden\" name=\"op\" value=\"NoMoveCategory\">";
        echo "<input type=\"hidden\" name=\"tit\" value=\"$tit\">";
        echo "<input type=\"submit\" value=\"" . _OK . "\">";
        echo "</form>";
    } else {
        $newcat = (int)$newcat;
        if ($newcat == -1) $newcat = 0;
        sql_query("update ${prefix}_stories set catid=" . intval($newcat) . " where catid=" . intval($catid));
        sql_query("DELETE FROM ${prefix}_stories_cat where catid=" . intval($catid));
        echo _MOVEDONE . "<br><br><a href='admin.php?op=CategoriesMenu'>" . _CATEGORIESADMIN . "</a>";
    } 
    CloseTable();

    include("footer.php");
} 

/**
 */
function mxDelStories($arrsid = array())
{
    global $prefix, $user_prefix;
    $insids = implode(',', $arrsid);
    $result = sql_query("select sid, catid, aid, informant FROM ${prefix}_stories WHERE sid IN (" . $insids . ")");
    if ($result) {
        $result = sql_query("DELETE FROM ${prefix}_stories WHERE sid IN (" . $insids . ")");
        if ($result) {
            sql_query("DELETE FROM ${prefix}_comments WHERE sid IN (" . $insids . ")");
            sql_query("UPDATE ${prefix}_poll_desc SET artid='0' WHERE artid IN (" . $insids . ")");
            while ($story = sql_fetch_assoc($result)) {
                if ($story['aid']) {
                    sql_query("UPDATE ${prefix}_authors SET counter=(counter-1) WHERE aid='" . mxAddSlashesForSQL($story['aid']) . "' AND counter > 0");
                } 
                if ($story['informant']) {
                    sql_query("UPDATE ${user_prefix}_users SET counter=(counter-1) WHERE uname='" . mxAddSlashesForSQL(substr($story['informant'], 0, 25)) . "' AND counter > 0");
                } 
            } 
            return true;
        } 
    } 
} 

/**
 */
function mxInsertPoll($story)
{
    global $prefix, $user_prefix;

    $story['sid'] = (empty($story['sid'])) ? 0 : intval($story['sid']);
    $story['pollID'] = (empty($story['pollID'])) ? 0 : intval($story['pollID']); 
    // check ob bereits Umfrage vorhanden
    $result = sql_query("SELECT pollID FROM ${prefix}_poll_desc WHERE artid=" . intval($story['sid']) . "");
    while ($poll = sql_fetch_assoc($result)) {
        // wenn bereits vorhanden, Funktion verlassen, nix machen
        if ($story['pollID'] && $story['pollID'] == $poll['pollID']) {
            return $story;
        } 
        // wenn beim Artikel keine Umfrage eingetragen war, aber in der Umfragentabelle
        // vorhanden, diesen Artikel aus der Umfragetabelle austragen
        if (!$story['pollID'] && $poll['pollID']) {
            sql_query("UPDATE ${prefix}_poll_desc SET artid=0 WHERE pollID=" . $poll['pollID'] . " AND artid=" . intval($story['sid']) . "");
        } 
    } 
    // ist eine Umfrage angefuegt?
    $attachedpoll = (empty($story['pollTitle']) || empty($story['optionText'][1]) || empty($story['optionText'][2])) ? 0 : 1; 
    // wenn noch keine Umfrage vorhanden ist, evtl. eine neue erstellen
    if (!$story['pollID'] && $story['sid'] && $attachedpoll) {
        // Umfragebeschreibung einfuegen
        $result = sql_query("INSERT INTO ${prefix}_poll_desc ( pollTitle,timeStamp,planguage,artid,pollactive) VALUES ('" . mxAddSlashesForSQL($story['pollTitle']) . "', '" . time() . "', '" . mxAddSlashesForSQL($story['alanguage']) . "'," . intval($story['sid']) . ",1)");
        if ($result) {
            // ID ermitteln
            $story['pollID'] = sql_insert_id();
            if ($story['pollID']) {
                // Umfragedaten einfuegen
                for($i = 1; $i <= sizeof($story['optionText']); $i++) {
                    sql_query("INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (" . intval($story['pollID']) . ", '" . mxAddSlashesForSQL($story['optionText'][$i]) . "', 0, " . intval($i) . ")");
                } 
                // ID in Artikel eintragen
                sql_query("UPDATE ${prefix}_stories SET pollID=" . intval($story['pollID']) . " WHERE sid=" . intval($story['sid']) . "");
            } 
        } 
    } 

    return $story;
} 

/**
 * #####   main   #################
 */
include_once("includes/mxNewsFunctions.php");

if (empty($sid)) $sid = 0;
if (empty($ok)) $ok = 0;

switch ($op) {
    case "CategoriesMenu":
        CategoriesMenu();
        break;

    case "EditCategory":
        CategoriesMenu();
        break;

    case "DelCategory":
        DelCategory($_GET);
        break;

    case "YesDelCategory":
        YesDelCategory();
        break;

    case "NoMoveCategory":
        NoMoveCategory($_REQUEST);
        break;

    case "SaveEditCategory":
        SaveEditCategory($_POST);
        break;

    case "SelectCategory":
        SelectCategory($cat);
        break;

    case "AddCategory":
        AddCategory();
        break;

    case "SaveCategory":
        SaveCategory($_POST);
        break;

    case "DisplayStory":
        DisplayStory($qid);
        break;

    case "adminStory":
        adminStory($sid);
        break;

    case "PreviewAgain":
    case "PreviewAdminStory":
        previewStory($_POST);
        break;

    case "PostAdminStory":
    case "PostStory":
        PostStory($_POST);
        break;

    case "EditStory":
        EditStory($sid);
        break;

    case "RemoveStory":
        RemoveStory($sid, $ok);
        break;

    case "ChangeStory":
        ChangeStory($_POST);
        break;

    case "DeleteStory":
        DeleteStory($qid, $ok);
        break;

    case "timedStories":
        timedStories();
        break;

    case "currentStories":
        currentStories();
        break;

    case "submissions":
    default:
        submissions();
        break;
} // end switch
